<?php

/**
 * @package     Joomla - > Site and Administrator payment info
 * @subpackage  com_Digicom
 * @subpackage 	joomina_Zarinpal
 * @copyright   joomina team => https://joomina.com
 * @copyright   Copyright (C) 20016 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;

class plgDigiCom_PaydigiirankishHelper
{

	public static function Storelog($name, $data)
	{
		$my = JFactory::getUser();
		jimport('joomla.log.log');
		JLog::addLogger(
			array(
				'text_file' => 'com_digicom.digiirankish.errors.php'
			),
			JLog::ALL,
			array('com_digicom.digiirankish')
		);
		$msg = 'StoreLog >>  user:' . $my->name . '(' . $my->id . '), desc: ' . json_encode($data['raw_data']);
		JLog::add($msg, JLog::WARNING, 'com_digicom.digiirankish');
	}

	function Fault_IranKish($err_code)
	{

		$msgArray = array(
			'5' => '‫از‬ ‫انجام‬ ‫تراکنش‬ ‫صرف‬ ‫نظر‬ ‫شد‬',
			'3' => '‫پذیرنده‬ ‫فروشگاهی‬ ‫نا‬ ‫معتبر‬ ‫است‬',
			'64' => '‫مبلغ‬ ‫تراکنش‬ ‫نادرست‬ ‫است‪،‬جمع‬ ‫مبالغ‬ ‫تقسیم‬ ‫وجوه‬ ‫برابر‬ ‫مبلغ‬ ‫کل‬ ‫تراکنش‬ ‫نمی‬ ‫باشد‬',
			'94' => '‫تراکنش‬ ‫تکراری‬ ‫است‬',
			'25' => '‫تراکنش‬ ‫اصلی‬ ‫یافت‬ ‫نشد‬',
			'77' => '‫روز‬ ‫مالی‬ ‫تراکنش‬ ‫نا‬ ‫معتبر‬ ‫است‬',
			'63' => '‫تمهیدات‬ ‫امنیتی‬ ‫نقض‬ ‫گردیده‬ ‫است‬',
			'97' => '‫کد‬ ‫تولید‬ ‫کد‬ ‫اعتبار‬ ‫سنجی‬ ‫نا‬ ‫معتبر‬ ‫است‬',
			'30' => '‫فرمت‬ ‫پیام‬ ‫نادرست‬ ‫است‬',
			'86' => '‫شتاب‬ ‫در‬ ‫حال‬ ‫‪Off‬‬ ‫‪Sign‬‬ ‫است‬',
			'55' => '‫رمز‬ ‫کارت‬ ‫نادرست‬ ‫است‬',
			'40' => '‫عمل‬ ‫درخواستی‬ ‫پشتیبانی‬ ‫نمی‬ ‫شود‬',
			'57' => '‫انجام‬ ‫تراکنش‬ ‫مورد‬ ‫درخواست‬ ‫توسط‬ ‫پایانه‬ ‫انجام‬ ‫دهنده‬ ‫مجاز‬ ‫نمی‬ ‫باشد‬',
			'58' => '‫انجام‬ ‫تراکنش‬ ‫مورد‬ ‫درخواست‬ ‫توسط‬ ‫پایانه‬ ‫انجام‬ ‫دهنده‬ ‫مجاز‬ ‫نمی‬ ‫باشد‬',
			'96' => '‫قوانین‬ ‫سامانه‬ ‫نقض‬ ‫گردیده‬ ‫است‬ ‫‪،‬‬ ‫خطای‬ ‫داخلی‬ ‫سامانه‬',
			'2' => '‫تراکنش‬ ‫قبال‬ ‫برگشت‬ ‫شده‬ ‫است‬',
			'54' => '‫تاریخ‬ ‫انقضا‬ ‫کارت‬ ‫سررسید‬ ‫شده‬ ‫است‬',
			'62' => '‫کارت‬ ‫محدود‬ ‫شده‬ ‫است‬',
			'75' => '‫تعداد‬ ‫دفعات‬ ‫ورود‬ ‫رمز‬ ‫اشتباه‬ ‫از‬ ‫حد‬ ‫مجاز‬ ‫فراتر‬ ‫رفته‬ ‫است‬',
			'14' => '‫اطالعات‬ ‫کارت‬ ‫صحیح‬ ‫نمی‬ ‫باشد‬',
			'51' => '‫موجودی‬ ‫حساب‬ ‫کافی‬ ‫نمی‬ ‫باشد‬',
			'56' => '‫اطالعات‬ ‫کارت‬ ‫یافت‬ ‫نشد‬',
			'61' => '‫مبلغ‬ ‫تراکنش‬ ‫بیش‬ ‫از‬ ‫حد‬ ‫مجاز‬ ‫است‬',
			'65' => '‫تعداد‬ ‫دفعات‬ ‫انجام‬ ‫تراکنش‬ ‫بیش‬ ‫از‬ ‫حد‬ ‫مجاز‬ ‫است‬',
			'78' => '‫کارت‬ ‫فعال‬ ‫نیست‬',
			'79' => '‫حساب‬ ‫متصل‬ ‫به‬ ‫کارت‬ ‫بسته‬ ‫یا‬ ‫دارای‬ ‫اشکال‬ ‫است‬',
			'42' => '‫کارت‬ ‫یا‬ ‫حساب‬ ‫مقصد‬ ‫در‬ ‫وضعیت‬ ‫پذیرش‬ ‫نمی‬ ‫باشد‬',
			'901' => '‫درخواست‬ ‫نا‬ ‫معتبر‬ ‫است‬ ‫(‬ ‫‪Tokenization‬‬ ‫)‬',
			'902' => '‫پارامترهای‬ ‫اضافی‬ ‫درخواست‬ ‫نامعتبر‬ ‫می‬ ‫باشد		‬ ‫(‬ ‫‪Tokenization‬‬ ‫)‬',
			'903' => '‫شناسه‬ ‫پرداخت‬ ‫نامعتبر‬ ‫می‬ ‫باشد‬ ‫(‬ ‫‪Tokenization‬‬ ‫)‬',
			'904' => '‫اطالعات‬ ‫مرتبط‬ ‫با‬ ‫قبض‬ ‫نا‬ ‫معتبر‬ ‫می‬ ‫باشد‬ ‫(‬ ‫‪Tokenization‬‬ ‫)‬',
			'905' => '‫شناسه‬ ‫درخواست‬ ‫نامعتبر‬ ‫می‬ ‫باشد‬ ‫(‬ ‫‪Tokenization‬‬ ‫)‬',
			'906' => '‫درخواست‬ ‫تاریخ‬ ‫گذشته‬ ‫است‬ ‫(‬ ‫‪Tokenization‬‬ ‫)‬',
			'907' => '‫آدرس‬ ‫بازگشت‬ ‫نتیجه‬ ‫پرداخت‬ ‫نامعتبر‬ ‫می‬ ‫باشد‬ ‫(‬ ‫‪Tokenization‬‬ ‫)‬',
			'909' => '‫پذیرنده‬ ‫نامعتبر‬ ‫می‬ ‫باشد(‬ ‫‪Tokenization‬‬ ‫)‬',
			'910' => '‫پارامترهای‬ ‫مورد‬ ‫انتظار‬ ‫پرداخت‬ ‫تسهیمی‬ ‫تامین‬ ‫نگردیده‬ ‫است(‬ ‫‪Tokenization‬‬ ‫)‬',
			'911' => '‫پارامترهای‬ ‫مورد‬ ‫انتظار‬ ‫پرداخت‬ ‫تسهیمی‬ ‫نا‬ ‫معتبر‬ ‫یا‬ ‫دارای‬ ‫اشکال‬ ‫می‬ ‫باشد(‬ ‫‪Tokenization‬‬ ‫)‬',
			'912' => '‫تراکنش‬ ‫درخواستی‬ ‫برای‬ ‫پذیرنده‬ ‫فعال‬ ‫نیست‬ ‫(‬ ‫‪Tokenization‬‬ ‫)‬',
			'913' => '‫تراکنش‬ ‫تسهیم‬ ‫برای‬ ‫پذیرنده‬ ‫فعال‬ ‫نیست‬ ‫(‬ ‫‪Tokenization‬‬ ‫)‬',
			'914' => '‫آدرس‬ ‫آی‬ ‫پی‬ ‫دریافتی‬ ‫درخواست‬ ‫نا‬ ‫معتبر‬ ‫می‬ ‫باشد‬',
			'915' => '‫شماره‬ ‫پایانه‬ ‫نامعتبر‬ ‫می‬ ‫باشد‬ ‫(‬ ‫‪Tokenization‬‬ ‫)‬',
			'916' => '‫شماره‬ ‫پذیرنده‬ ‫نا‬ ‫معتبر‬ ‫می‬ ‫باشد‬ ‫(‬ ‫‪Tokenization‬‬ ‫)‬',
			'917' => '‫نوع‬ ‫تراکنش‬ ‫اعالم‬ ‫شده‬ ‫در‬ ‫خواست‬ ‫نا‬ ‫معتبر‬ ‫می‬ ‫باشد‬ ‫(‬ ‫‪Tokenization‬‬ ‫)‬',
			'918' => '‫پذیرنده‬ ‫فعال‬ ‫نیست‬',
			'919' => '‫مبالغ‬ ‫تسهیمی‬ ‫ارائه‬ ‫شده‬ ‫با‬ ‫توجه‬ ‫به‬ ‫قوانین‬ ‫حاکم‬ ‫بر‬ ‫وضعیت‬ ‫تسهیم‬ ‫پذیرنده‬ ‫‪،‬‬ ‫نا‬ ‫معتبر‬ ‫است‬ ‫(‬ ‫‪Tokenization‬‬ ‫)‬',
			'920' => '‫شناسه‬ ‫نشانه‬ ‫نامعتبر‬ ‫می‬ ‫باشد‬',
			'921' => '‫شناسه‬ ‫نشانه‬ ‫نامعتبر‬ ‫و‬ ‫یا‬ ‫منقضی‬ ‫شده‬ ‫است‬',
			'922' => '‫نقض‬ ‫امنیت‬ ‫درخواست‬ ‫(‬ ‫‪Tokenization‬‬ ‫)‬',
			'923' => '‫ارسال‬ ‫شناسه‬ ‫پرداخت‬ ‫در‬ ‫تراکنش‬ ‫قبض‬ ‫مجاز‬ ‫نیست‬ ‫(‬ ‫‪Tokenization‬‬ ‫)‬',
			'925' => '‫مبلغ‬ ‫مبادله‬ ‫شده‬ ‫نا‬ ‫معتبر‬ ‫می‬ ‫باشد‬',
		);

		if (isset($msgArray[$err_code])) {
			return $msgArray[$err_code];
		}
		return 'در حین پرداخت خطای سیستمی رخ داده است .' . $err_code;
	}

	public static function getPayerPrice($id)
	{
		$user = JFactory::getUser();
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select('amount')
			->from($db->qn('#__digicom_orders'));
		$query->where(
			$db->qn('userid') . ' = ' . $db->q($user->id)
				. ' AND ' .
				$db->qn('id') . ' = ' . $db->q($id)
		);
		$db->setQuery((string) $query);
		$result = $db->loadResult();
		return $result;
	}
}
